package org.vraptor.plugin.hibernate;

import java.util.Collection;

import org.vraptor.component.ComponentType;
import org.vraptor.component.LogicMethod;
import org.vraptor.component.LogicNotFoundException;

/**
 * Deals with hibernate validator component registering.
 * 
 * @author Guilherme Silveira 
 */
class ValidatorControl {

	boolean needsToWrap(ComponentType component) throws LogicNotFoundException {
		Collection<LogicMethod> logics = component.getLogics();
		for (LogicMethod logic : logics) {
			if (logic.getMetadata().containsAnnotation(Validate.class)) {
				return true;
			}
		}
		return false;
	}

	ComponentType wrapComponent(HibernateValidatorPlugin plugin, ComponentType component) {
		return new HibernateComponent(component, plugin.locator);
	}

}
